Unit AM02C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM02C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var R :Array of Complex;
                var S :Real; N :Integer; M :Integer);

implementation

procedure AM02C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var R :Array of Complex;
                var S :Real; N :Integer; M :Integer);
var
I,J :Integer;
S1,S2,F1,F2 :Real;
E,G,F :Extended;
C :Complex;
const
SYS056 :Extended = 5.56268464627e-308;
label
_1,_2,_3,_4,_5,_6,_7;
begin
F := 0.0e0;
for J:=1 to N do
 begin
  E := 0.0e0;
  G := 0.0e0;
  for I:=1 to M do
   begin
    C := A[(J-1)+(I-1)*N];
    S1 := Creal(C);
    S2 := Aimag(C);
    C := X[I-1];
    F1 := Creal(C);
    F2 := Aimag(C);
    E := E+(S1)*(F1)-(S2)*(F2);
_1:
    G := G+(S2)*(F1)+(S1)*(F2);
   end;
  C := B[J-1];
  S1 := Creal(C);
  S2 := Aimag(C);
  E := Abs(E-(S1));
  G := Abs(G-(S2));
  if ( E <= F ) 
   then goto _2;
  F := E;
_2:
  if ( G <= F ) 
   then goto _3;
  F := G;
_3:
 end;
S := F;
if ( F >= SYS056 ) 
 then goto _4;
S := 0.0;
goto _7;
_4:
F := 1.e0/F;
for J:=1 to N do
 begin
  E := 0.0e0;
  G := 0.0e0;
  for I:=1 to M do
   begin
    C := A[(J-1)+(I-1)*N];
    S1 := Creal(C);
    S2 := Aimag(C);
    C := X[I-1];
    F1 := Creal(C);
    F2 := Aimag(C);
    E := E+(S1)*(F1)-(F2)*(S2);
_5:
    G := G+(S2)*(F1)+(S1)*(F2);
   end;
  C := B[J-1];
  S1 := Creal(C);
  S2 := Aimag(C);
  E := ((S1)-E)*F;
  G := ((S2)-G)*F;
_6:
  R[J-1] := Cmplx(E,G);
 end;
_7:
end;

end.
